// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.



#include <qlabel.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qmultilineedit.h>
#include <qbutton.h>
#include <qtoolbutton.h>
//#include <qbuttongroup.h>
#include <qlayout.h>
#include <qpixmap.h>

#include <string>
#include <list>
using namespace std;

#include "selecticon.xpm"
#include "freehandicon.xpm"
#include "lineicon.xpm"
#include "circleicon.xpm"
#include "coord.h"
#include "ptneditview.h"
#include "ptneditdialog.h"

ptneditDialog::ptneditDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setProperty( "name", "ptneditDialogBase" );
	setCaption("Qt-LCo Pattern editor");
	
	menuBar = new QMenuBar(this); 

	QPopupMenu * file = new QPopupMenu( this );
    menuBar->insertItem( "&File", file );
	//file->insertItem( "&Import image...",this, SLOT(importImage()) );
	//file->insertItem( "&Export image...",this, SLOT(exportImage()) );
 	file->insertItem( "&Close", this, SLOT(accept()) );
	//EDIT˥塼
    QPopupMenu * edit = new QPopupMenu( this );
	menuBar->insertItem( "&Edit", edit);
    m_nMenuIdEditCut = edit->insertItem( "Cu&t", this, SLOT(EditCut()), CTRL+Key_X );
    m_nMenuIdEditCopy = edit->insertItem( "&Copy", this, SLOT(EditCopy()), CTRL+Key_C );
    m_nMenuIdEditPaste = edit->insertItem( "&Paste", this, SLOT(EditPaste()), CTRL+Key_V );
    m_nMenuIdEditDelete = edit->insertItem( "&Delete", this, SLOT(EditDelete()), Key_Delete);
	edit->insertSeparator();
    m_nMenuIdEditMirror = edit->insertItem( "&Mirror", this, SLOT(EditMirror()), CTRL+Key_M );
    m_nMenuIdEditRotate = edit->insertItem( "&Rotate", this, SLOT(EditRotate()), CTRL+Key_R );

	//TOOL˥塼
    QPopupMenu * tool = new QPopupMenu( this );
    menuBar->insertItem( "&Tool", tool);
    m_nMenuIdToolSelect = tool->insertItem( "&Select", this, SLOT(ToolSelector()));
    m_nMenuIdToolFreehand = tool->insertItem( "&Freehand", this, SLOT(ToolFreehand()));
    m_nMenuIdToolLine = tool->insertItem( "&Line", this, SLOT(ToolLine()));
    m_nMenuIdToolCircle = tool->insertItem( "&Circle", this, SLOT(ToolCircle()));


	//VIEW˥塼
    QPopupMenu * view = new QPopupMenu( this );
    menuBar->insertItem( "&View", view);
    m_nMenuIdViewZoomIn = view->insertItem( "Zoom &In", this, SLOT(ViewZoomIn()), Key_PageUp );
    m_nMenuIdViewZoomOut = view->insertItem( "Zoom &Out", this, SLOT(ViewZoomOut()), Key_PageDown );

 	
	resize( 350, 400 );

	m_nTool = SPtnEditView::TOOL_SELECTOR;
	
	//ġܥΤΥ᡼ν
    QPixmap image_selecticon( ( const char** ) selecticon );
    QPixmap image_freehandicon( ( const char** ) freehandicon );
    QPixmap image_lineicon( ( const char** ) lineicon );
    QPixmap image_circleicon( ( const char** ) circleicon );

	//ġܥΥ쥤ȤԤWidget
	//λҥɥȤƿʿ쥤ȥޥ͡
	//οʿ쥤ȥޥ͡˥ܥ쥤Ȥ롣
	toolBtnLayoutWidget= new QWidget( this, "ToolBtnLayout" );
    //toolBtnLayoutWidget->setGeometry( QRect( 20, 240, 476, 33 ) ); 
    toolBtnLayout = new QHBoxLayout( toolBtnLayoutWidget ); 
    toolBtnLayout->setSpacing( 0 );
    toolBtnLayout->setMargin( 0 );
	
	//ܥ
	btnToolSelect = new QToolButton( toolBtnLayoutWidget, "btnToolSelect");
	btnToolSelect->setTextLabel("Select");
	QObject::connect(btnToolSelect,SIGNAL( clicked() ),this,SLOT( ToolSelector() ));
	//, QString::null,		   this, SLOT(ToolSelector()),m_toolbar, "Select" );
    //btnToolSelect->setProperty( "text", tr( "" ) );
    btnToolSelect->setPixmap(image_selecticon);//setProperty( "pixmap", image0 );
    toolBtnLayout->addWidget( btnToolSelect );

	//ե꡼ϥɥܥ
    btnToolFreehand = new QToolButton( toolBtnLayoutWidget, "btnToolFreehand" );
	btnToolFreehand->setTextLabel("Freehand");
	QObject::connect(btnToolFreehand,SIGNAL( clicked() ),this,SLOT( ToolFreehand() ));
    //btnToolFreehand->setProperty( "text", tr( "" ) );
    btnToolFreehand->setPixmap(image_freehandicon);//setProperty( "pixmap", image1 );
    toolBtnLayout->addWidget( btnToolFreehand );

	//ľܥ
    btnToolLine = new QToolButton( toolBtnLayoutWidget, "btnToolLine" );
 	btnToolLine->setTextLabel("Line");
	QObject::connect(btnToolLine,SIGNAL( clicked() ),this,SLOT( ToolLine() ));
	//btnToolLine->setProperty( "text", tr( "" ) );
    btnToolLine->setPixmap(image_lineicon);//setProperty( "pixmap", image2 );
    toolBtnLayout->addWidget( btnToolLine );

	//ߥܥ
    btnToolCircle = new QToolButton( toolBtnLayoutWidget, "btnToolCircle" );
	btnToolCircle->setTextLabel("Circle");
	QObject::connect(btnToolCircle,SIGNAL( clicked() ),this,SLOT( ToolCircle() ));
    //btnToolCircle->setProperty( "text", tr( "" ) );
    btnToolCircle->setPixmap(image_circleicon);//setProperty( "pixmap", image3 );
    toolBtnLayout->addWidget( btnToolCircle );





/*
	toolBtnGroup = new QButtonGroup(this,"ToolBtnGroup");
	toolBtnGroup->insert(btnToolSelect);
	toolBtnGroup->insert(btnToolFreehand);
	toolBtnGroup->insert(btnToolLine);
	toolBtnGroup->insert(btnToolCircle);
	toolBtnGroup->setExclusive (true); 
*/	




	m_pPtnEditView = new SPtnEditView(this);
	setChildSize();
	setToolState();

	/*
    setProperty( "caption", tr( "ptnedit" ) );
    setProperty( "sizeGripEnabled", QVariant( TRUE, 0 ) );

    QWidget* privateLayoutWidget = new QWidget( this, "Layout1" );
    privateLayoutWidget->setGeometry( QRect( 20, 240, 476, 33 ) ); 
    Layout1 = new QHBoxLayout( privateLayoutWidget ); 
    Layout1->setSpacing( 6 );
    Layout1->setMargin( 0 );

    buttonHelp = new QPushButton( privateLayoutWidget, "buttonHelp" );
    buttonHelp->setProperty( "text", tr( "&Help" ) );
    buttonHelp->setProperty( "autoDefault", QVariant( TRUE, 0 ) );
    Layout1->addWidget( buttonHelp );
    QSpacerItem* spacer = new QSpacerItem( 0, 0, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout1->addItem( spacer );

    buttonApply = new QPushButton( privateLayoutWidget, "buttonApply" );
    buttonApply->setProperty( "text", tr( "&Apply" ) );
    buttonApply->setProperty( "autoDefault", QVariant( TRUE, 0 ) );
    Layout1->addWidget( buttonApply );

    buttonOk = new QPushButton( privateLayoutWidget, "buttonOk" );
    buttonOk->setProperty( "caption", tr( "" ) );
    buttonOk->setProperty( "text", tr( "&OK" ) );
    buttonOk->setProperty( "autoDefault", QVariant( TRUE, 0 ) );
    buttonOk->setProperty( "default", QVariant( TRUE, 0 ) );
    Layout1->addWidget( buttonOk );

    buttonCancel = new QPushButton( privateLayoutWidget, "buttonCancel" );
    buttonCancel->setProperty( "text", tr( "&Cancel" ) );
    buttonCancel->setProperty( "autoDefault", QVariant( TRUE, 0 ) );
    Layout1->addWidget( buttonCancel );

    TextLabel1 = new QLabel( this, "TextLabel1" );
    TextLabel1->setGeometry( QRect( 200, 120, 116, 13 ) ); 
    TextLabel1->setProperty( "text", tr( "Place your widgets here!" ) );

    // signals and slots connections
    connect( buttonOk, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
*/
}

/*  
 *  Destroys the object and frees any allocated resources
 */
ptneditDialog::~ptneditDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

void ptneditDialog::reject()
{
}


#define TOOLBAR_HEIGHT 24
#define TOOLBUTTON_WIDTH 24


void ptneditDialog::setChildSize()
{
	toolBtnLayoutWidget->setGeometry( QRect(0,menuBar->height(), TOOLBUTTON_WIDTH*4, TOOLBAR_HEIGHT ) );
	m_pPtnEditView->setGeometry(0,TOOLBAR_HEIGHT+menuBar->height(),width(),height()-menuBar->height()-TOOLBAR_HEIGHT);
}

void ptneditDialog::resizeEvent( QResizeEvent * event)
{
	setChildSize();
}

void ptneditDialog::setToolState()
{
	menuBar->setItemChecked(m_nMenuIdToolSelect,m_nTool == SPtnEditView::TOOL_SELECTOR);
	menuBar->setItemChecked(m_nMenuIdToolFreehand,m_nTool == SPtnEditView::TOOL_FREEHAND);
	menuBar->setItemChecked(m_nMenuIdToolLine,m_nTool == SPtnEditView::TOOL_LINE);
	menuBar->setItemChecked(m_nMenuIdToolCircle,m_nTool == SPtnEditView::TOOL_CIRCLE);


	btnToolSelect->setDown(m_nTool == SPtnEditView::TOOL_SELECTOR);
	btnToolFreehand->setDown(m_nTool == SPtnEditView::TOOL_FREEHAND);
	btnToolLine->setDown(m_nTool == SPtnEditView::TOOL_LINE);
	btnToolCircle->setDown(m_nTool == SPtnEditView::TOOL_CIRCLE);
}


//᡼Υݡ
void ptneditDialog::importImage()
{
}
//᡼Υݡ
void ptneditDialog::exportImage()
{
}

//å
void ptneditDialog::EditCut()
{
	m_pPtnEditView->cut();
}
//ԡ
void ptneditDialog::EditCopy()
{
	m_pPtnEditView->copy();
}
//ڡ
void ptneditDialog::EditPaste()
{
	m_pPtnEditView->paste();
}
//
void ptneditDialog::EditDelete()
{
	m_pPtnEditView->del();
}
//ȿž
void ptneditDialog::EditMirror()
{
	m_pPtnEditView->mirror();
}
//ž
void ptneditDialog::EditRotate()
{
	m_pPtnEditView->rotate();
}
//ɽ
void ptneditDialog::ViewZoomIn()
{
	m_pPtnEditView->ZoomIn();
	menuBar->setItemEnabled(m_nMenuIdViewZoomOut,m_pPtnEditView->CanZoomOut());
	menuBar->setItemEnabled(m_nMenuIdViewZoomIn,m_pPtnEditView->CanZoomIn());
}
//ɽ̾
void ptneditDialog::ViewZoomOut()
{
	m_pPtnEditView->ZoomOut();
	menuBar->setItemEnabled(m_nMenuIdViewZoomOut,m_pPtnEditView->CanZoomOut());
	menuBar->setItemEnabled(m_nMenuIdViewZoomIn,m_pPtnEditView->CanZoomIn());
}
//ġ
void ptneditDialog::ToolSelector()
{
	//qDebug("ToolSelector()");
	m_nTool = SPtnEditView::TOOL_SELECTOR;
	setToolState();
	m_pPtnEditView->setToolMode(SPtnEditView::TOOL_SELECTOR);
}
//ե꡼ϥɥġ
void ptneditDialog::ToolFreehand()
{
	m_nTool = SPtnEditView::TOOL_FREEHAND;
	setToolState();
	m_pPtnEditView->setToolMode(SPtnEditView::TOOL_FREEHAND);
}
//ġ
void ptneditDialog::ToolLine()
{
	m_nTool = SPtnEditView::TOOL_LINE;
	setToolState();
	m_pPtnEditView->setToolMode(SPtnEditView::TOOL_LINE);
}
//ߥġ
void ptneditDialog::ToolCircle()
{
	m_nTool = SPtnEditView::TOOL_CIRCLE;
	setToolState();
	m_pPtnEditView->setToolMode(SPtnEditView::TOOL_CIRCLE);
}
